from collections import deque, defaultdict
def find_guarded_warehouses(n, m, k, roads, guards):
    graph = defaultdict(list)

    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)

    guarded = set()

    for pi, hi in guards:
        queue = deque([(pi, 0)])
        visited = set()
        visited.add(pi)

        while queue:
            current_warehouse, distance = queue.popleft()
            if distance <= hi:
                guarded.add(current_warehouse)
                for neighbor in graph[current_warehouse]:
                    if neighbor not in visited:
                        visited.add(neighbor)
                        queue.append((neighbor, distance + 1))
    return sorted(guarded)

if __name__ == "__main__":
    n, m, k = map(int, input().split())
    roads = [tuple(map(int, input().split())) for _ in range(m)]
    guards = [tuple(map(int, input().split())) for _ in range(k)]

    result = find_guarded_warehouses(n, m, k, roads, guards)
    print(" ".join(map(str, result)))