import itertools
def calculate_distance(p1, p2):
    return abs(p1[0] - p2[0]) + abs(p1[1] - p2[1])
def tsp(points):
    n = len(points)
    min_path_length = float('inf')
    for perm in itertools.permutations(range(n)):
        current_length = 0
        for i in range(n - 1):
            current_length += calculate_distance(points[perm[i]], points[perm[i + 1]])
        min_path_length = min(min_path_length, current_length)

    return min_path_length
n = int(input())
points = [tuple(map(int, input().split())) for _ in range(n)]
result = tsp(points)
print(f"{result:.6f}")